diff -ur slackware64-current.2/source/n/dhcpcd/dhcpcd.SlackBuild slackware64-current.3/source/n/dhcpcd/dhcpcd.SlackBuild
--- slackware64-current.2/source/n/dhcpcd/dhcpcd.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/dhcpcd/dhcpcd.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -75,6 +75,10 @@
 rm -rf dhcpcd-$VERSION
 tar xvf $CWD/dhcpcd-$VERSION.tar.?z || exit 1
 cd dhcpcd-$VERSION
+
+# Add loongarch64 AUDIT support:
+patch -p1 --verbose < $CWD/patches/loongarch_audit_support.patch || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/n/gnutls/gnutls.SlackBuild slackware64-current.3/source/n/gnutls/gnutls.SlackBuild
--- slackware64-current.2/source/n/gnutls/gnutls.SlackBuild.orig	2024-08-15 21:53:29.399070630 +0200
+++ slackware64-current.3/source/n/gnutls/gnutls.SlackBuild	2025-01-07 13:31:30.923043522 +0100
@@ -57,6 +57,12 @@
   LIBDIRSUFFIX=""
 fi
 
+case "$ARCH" in
+    arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+    mips64el) TARGET=$ARCH-slackware-linux-gnuabi64 ;;
+    *)    TARGET=$ARCH-slackware-linux ;;
+esac
+
 # Don't use icecream:
 PATH=$(echo $PATH | sed "s|/usr/libexec/icecc/bin||g" | tr -s : | sed "s/^://g" | sed "s/:$//g")
 
@@ -80,7 +86,12 @@
   -exec chmod 644 {} \+
 
 # Need to reconf to find guile-3.0.x:
-autoreconf -vif
+which guile >/dev/null 2>&1
+if [ $? -eq 0 ] ; then
+  autoreconf -vif
+else
+  DISABLEGUILE="--disable-guile"
+fi
 
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
@@ -99,8 +110,9 @@
   --with-idn \
   --with-zstd \
   --enable-openssl-compatibility \
-  --build=$ARCH-slackware-linux \
-  --host=$ARCH-slackware-linux || exit 1
+  $DISABLE_GUILE \
+  --build=$TARGET \
+  --host=$TARGET || exit 1
 
 make $NUMJOBS || make || exit 1
 make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/n/gpgme/gpgme.SlackBuild slackware64-current.3/source/n/gpgme/gpgme.SlackBuild
--- slackware64-current.2/source/n/gpgme/gpgme.SlackBuild	2025-01-01 22:18:41.118561526 +0100
+++ slackware64-current.3/source/n/gpgme/gpgme.SlackBuild	2025-01-07 13:31:31.013048336 +0100
@@ -88,8 +88,9 @@
   --enable-languages="cl cpp python qt5 qt6" \
   --disable-gpg-test \
   --docdir=/usr/doc/gpgme-$VERSION \
-  --build=$ARCH-slackware-linux \
-  --host=$ARCH-slackware-linux || exit 1
+  || exit 1
+# Remove --build and --host otherwise gcc not detected on arm and 
+# arm-slackware-linux-clang++ has by default armv4 (not supported by qt)
 
 make $NUMJOBS || make || exit 1
 make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/n/iptraf-ng/iptraf-ng.SlackBuild slackware64-current.3/source/n/iptraf-ng/iptraf-ng.SlackBuild
--- slackware64-current.2/source/n/iptraf-ng/iptraf-ng.SlackBuild	2021-02-13 06:32:04.693944925 +0100
+++ slackware64-current.3/source/n/iptraf-ng/iptraf-ng.SlackBuild	2021-09-18 13:42:55.877046543 +0200
@@ -71,6 +71,17 @@
 
 zcat $CWD/iptraf-ng.paths.diff.gz | patch -p1 --verbose || exit 1
 
+# Patch for unaligned buffer: since could drop performance (a copy is 
+# done for every packet), apply only on known architecture that does
+# not work with unaligned copy (armv5te, mips*, sparc*):
+if [ "$ARCH" = "arm" -o "${ARCH::4}" = "mips" -o "${ARCH::5}" = "sparc" -o "$ARCH" = "hppa" ]
+then
+  zcat $CWD/unaligned_copy.diff.gz | patch -p1 --verbose || exit 1
+fi
+
+# Fix printf size (does not match longlong/long/int):
+zcat $CWD/fix_printf_int_sizes.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/n/netatalk/netatalk.SlackBuild slackware64-current.3/source/n/netatalk/netatalk.SlackBuild
--- slackware64-current.2/source/n/netatalk/netatalk.SlackBuild	2024-10-08 13:45:06.206276993 +0200
+++ slackware64-current.3/source/n/netatalk/netatalk.SlackBuild	2024-10-09 16:13:50.588820279 +0200
@@ -71,6 +71,10 @@
 rm -rf netatalk-$VERSION
 tar xvf $CWD/netatalk-$VERSION.tar.?z* || exit 1
 cd netatalk-$VERSION || exit 1
+
+# Fix incorrect 'arch' distro detection for loongarch64:
+zcat $CWD/fix_distro_slackware.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/n/nn/nn.SlackBuild slackware64-current.3/source/n/nn/nn.SlackBuild
--- slackware64-current.2/source/n/nn/nn.SlackBuild	2021-02-13 06:32:06.037944850 +0100
+++ slackware64-current.3/source/n/nn/nn.SlackBuild	2021-09-18 13:42:55.917048562 +0200
@@ -80,7 +80,7 @@
     | sed -e "s#m-sparc.h#${MFILE}#" \
     | sed -e "s#/usr/lib/nn#/usr/lib${LIBDIRSUFFIX}/nn#" \
     | patch -p0 --verbose || exit 1
-if [ $ARCH = "x86_64" ]; then
+if [ "$MFILE" = "m-x86_64.h" ]; then
 	zcat $CWD/m-x86_64.h.gz > conf/m-x86_64.h
 fi
 zcat $CWD/nn.badnntphost.diff.gz | patch -p1 --verbose || exit 1
diff -ur slackware64-current.2/source/n/ntp/ntp.SlackBuild slackware64-current.3/source/n/ntp/ntp.SlackBuild
--- slackware64-current.2/source/n/ntp/ntp.SlackBuild	2024-10-24 20:32:48.085703081 +0200
+++ slackware64-current.3/source/n/ntp/ntp.SlackBuild	2025-01-07 13:31:31.543076686 +0100
@@ -69,6 +69,9 @@
 tar xvf $CWD/ntp-${VERSION}*.tar.?z* || exit 1
 cd ntp-${VERSION}* || exit 1
 
+# Fix invalid PTHREAD_STACK_MIN macro on or1k:
+sed -i 's/^#ifndef __sun/#if !defined(__sun) \&\& !defined(__or1k__)/' libntp/work_thread.c
+
 chown -R root:root .
 find . \
   \( -perm 2777 -o -perm 2755 -o -perm 2775 \) \
diff -ur slackware64-current.2/source/n/openssh/openssh.SlackBuild slackware64-current.3/source/n/openssh/openssh.SlackBuild
--- slackware64-current.2/source/n/openssh/openssh.SlackBuild	2023-10-06 19:00:26.131609140 +0200
+++ slackware64-current.3/source/n/openssh/openssh.SlackBuild	2024-01-08 17:56:19.419184410 +0100
@@ -99,6 +102,13 @@
 
 autoreconf -vif
 
+# MIPS big-endian, as well PPC64LE, do not like -fzero-call-used-regs=used 
+# (internal compiler error during RTL pass: zero_call_used_regs or 
+# sshkey.c:3713:1: sorry, unimplemented: argument 'used' is not supported for '-fzero-call-used-regs' on this target)
+if [ "$ARCH" = "mips" -o "$ARCH" = "ppc64le" ]; then
+  sed -i 's/-fzero-call-used-regs=used//' configure
+fi
+
 # Compile package:
 CFLAGS="$SLKCFLAGS" \
 ./configure \
diff -ur slackware64-current.2/source/n/openssl/openssl.SlackBuild slackware64-current.3/source/n/openssl/openssl.SlackBuild
--- slackware64-current.2/source/n/openssl/openssl.SlackBuild	2021-02-16 20:16:39.664000909 +0100
+++ slackware64-current.3/source/n/openssl/openssl.SlackBuild	2021-09-18 13:42:55.957050581 +0200
@@ -110,6 +110,9 @@
   touch -r CHANGES $DOCSDIR/CHANGES
 fi
 
+# Add patch for various arch default auto-configuration:
+zcat $CWD/fix_autoconfiguration.diff.gz | patch -p1 --verbose || exit 1
+
 # These are the known patent issues with OpenSSL:
 # name   #         expires
 # MDC-2: 4,908,861  2007-03-13, not included.
@@ -119,9 +122,10 @@
 # not a good idea to include them as there are better
 # algorithms to use.
 
-./config \
+LDFLAGS=$SLKLDFLAGS KERNEL_BITS=$LIBDIRSUFFIX ./config \
  --prefix=/usr \
  --openssldir=/etc/ssl \
+ --libdir=lib${LIBDIRSUFFIX} \
  zlib \
  enable-camellia \
  enable-seed \
diff -ur slackware64-current.2/source/n/php/php.SlackBuild slackware64-current.3/source/n/php/php.SlackBuild
--- slackware64-current.2/source/n/php/php.SlackBuild	2010-08-12 18:05:09.000000000 +0200
+++ slackware64-current.3/source/n/php/php.SlackBuild	2017-11-08 00:43:15.725031287 +0100
@@ -145,6 +145,9 @@
   zcat $CWD/php.configure.s390.diff.gz | patch -p1 || exit
 fi
 
+# Fix forced inline for sh4:
+zcat $CWD/sh4_inline.diff.gz | patch -p1 --verbose || exit 1
+
 # Fixup perms/owners:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/n/pinentry/pinentry.SlackBuild slackware64-current.3/source/n/pinentry/pinentry.SlackBuild
--- slackware64-current.2/source/n/pinentry/pinentry.SlackBuild	2024-04-06 20:30:23.204221653 +0200
+++ slackware64-current.3/source/n/pinentry/pinentry.SlackBuild	2024-05-02 01:06:58.393994037 +0200
@@ -47,6 +47,11 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+# No more needed (successfully compiled qt6 without webengine), but leave it as option.
+if [ -f /usr/bin/qmake6 ]; then
+  QT6OPT="--enable-pinentry-qt"
+fi
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -98,7 +102,7 @@
   --enable-fallback-curses \
   --enable-pinentry-emacs \
   --enable-pinentry-gtk2 \
-  --enable-pinentry-qt \
+  $QT6OPT \
   --enable-pinentry-tty \
   --build=$ARCH-slackware-linux$ARCHQUADLET \
   --host=$ARCH-slackware-linux$ARCHQUADLET || exit 1
diff -ur slackware64-current.2/source/n/s-nail/s-nail.SlackBuild slackware64-current.3/source/n/s-nail/s-nail.SlackBuild
--- slackware64-current.2/source/n/s-nail/s-nail.SlackBuild	2021-02-24 19:51:46.341919611 +0100
+++ slackware64-current.3/source/n/s-nail/s-nail.SlackBuild	2021-09-18 13:42:56.027054114 +0200
@@ -96,7 +96,12 @@
   config || exit 1
 
 make $NUMJOBS build || exit 1
+
+# Test failed on arch different then x86
+if [ `echo $ARCH|grep -c 86` -gt 0 ]]
+then
 make $NUMJOBS test || exit 1
+fi
 make install DESTDIR=$PKG || exit 1
 
 # Tighten up the perms a bit:
diff -ur slackware64.1/source/n/samba/samba.SlackBuild slackware64.2/source/n/samba/samba.SlackBuild
--- slackware64.1/source/n/samba/samba.SlackBuild	2023-04-24 16:18:30.756016051 +0200
+++ slackware64.2/source/n/samba/samba.SlackBuild	2023-09-19 13:05:40.802851431 +0200
@@ -130,7 +130,7 @@
 # build in.
 #
 # LDFLAGS are needed to avoid problems with missing symbols.
-LDFLAGS="-Wl,--no-as-needed" \
+LDFLAGS="-Wl,--no-as-needed $SLKLDFLAGS" \
 CFLAGS="$SLKCFLAGS" \
 ./configure \
   --enable-fhs \
diff -ur slackware64-current.2/source/n/vsftpd/vsftpd.SlackBuild slackware64-current.3/source/n/vsftpd/vsftpd.SlackBuild
--- slackware64-current.2/source/n/vsftpd/vsftpd.SlackBuild	2010-08-12 18:05:09.000000000 +0200
+++ slackware64-current.3/source/n/vsftpd/vsftpd.SlackBuild	2017-11-08 00:43:15.725031287 +0100
@@ -69,6 +69,12 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ "$ARCH" = "alpha" -o "$ARCH" = "hppa" ]
+then
+  # GCC for alpha and hppa does not implement -fstack-protector
+  sed -i 's/-fstack-protector//' Makefile
+fi
+
 zcat $CWD/vsftpd.builddefs.diff.gz | patch -p1 --verbose || exit 1
 zcat $CWD/vsftpd.conf.diff.gz | patch -p1 --verbose || exit 1
 zcat $CWD/vsftpd.crypt.diff.gz | patch -p1 --verbose || exit 1
diff -ur slackware64-current.2/source/t/texlive/texlive.SlackBuild slackware64-current.3/source/t/texlive/texlive.SlackBuild
--- slackware64-current.2/source/t/texlive/texlive.SlackBuild	2024-11-28 00:19:02.289140668 +0100
+++ slackware64-current.3/source/t/texlive/texlive.SlackBuild	2025-01-07 13:31:35.143269248 +0100
@@ -83,6 +83,17 @@
 # Don't break texdoc et al every time zlib is upgraded:
 cat $CWD/patches/quit-breaking-on-minor-zlib-bump.patch | patch -p1 --verbose || exit 1
 
+# Fix incorrect MIPS64 architecture detection on LuaJIT:
+zcat $CWD/patches/mips64_configure_fix.diff.gz | patch -p1 --verbose || exit 1
+
+XINDY="--enable-xindy --with-clisp-runtime=system"
+
+which clisp 2>/dev/null
+if [ $? -ne 0 ]
+then
+  XINDY=""
+fi
+
 mkdir build
 cd build
   CFLAGS="$SLKCFLAGS -Wno-error=incompatible-pointer-types" \
@@ -104,11 +115,11 @@
     --disable-xz \
     --disable-texdoctk \
     --with-x \
-    --enable-xindy \
+    $XINDY \
+    $EXTRATEX \
     --disable-xindy-docs \
     --disable-xindy-rules \
     --disable-linked-scripts \
-    --with-clisp-runtime=system \
     --enable-gc=system \
     --with-system-libpng \
     --with-system-t1lib \
diff -ur slackware64-current.2/source/x/compiz/compiz.SlackBuild slackware64-current.3/source/x/compiz/compiz.SlackBuild
--- slackware64-current.2/source/x/compiz/compiz.SlackBuild	2025-06-02 00:02:22.849676141 +0200
+++ slackware64-current.3/source/x/compiz/compiz.SlackBuild	2025-06-10 08:24:13.089980520 +0200
@@ -75,6 +75,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Be compatible with patched startup-notification for time64 on 32 bit systems:
+zcat $CWD/libsn_time64.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/x/fcitx5-chinese-addons/fcitx5-chinese-addons.SlackBuild slackware64-current.3/source/x/fcitx5-chinese-addons/fcitx5-chinese-addons.SlackBuild
--- slackware64-current.2/source/x/fcitx5-chinese-addons/fcitx5-chinese-addons.SlackBuild	2025-06-18 10:14:39.563906089 +0200
+++ slackware64-current.3/source/x/fcitx5-chinese-addons/fcitx5-chinese-addons.SlackBuild	2025-07-08 22:41:42.137311465 +0200
@@ -79,6 +79,13 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ -d "/usr/lib$LIBDIRSUFFIX/cmake/Qt6WebEngineWidgets" ]
+then
+  ENABLE_BROWSER=On
+else
+  ENABLE_BROWSER=Off
+fi
+
 mkdir build
 cd build
   cmake \
@@ -86,7 +93,7 @@
     -DCMAKE_C_FLAGS="${SLKCFLAGS}" \
     -DCMAKE_INSTALL_PREFIX="/usr" \
     -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
-    -DUSE_QT6=Off \
+    -DENABLE_BROWSER=$ENABLE_BROWSER \
     ..
 
   make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/x/fcitx5-qt/fcitx5-qt.SlackBuild slackware64-current.3/source/x/fcitx5-qt/fcitx5-qt.SlackBuild
--- slackware64-current.2/source/x/fcitx5-qt/fcitx5-qt.SlackBuild	2024-04-25 16:22:31.957498256 +0200
+++ slackware64-current.3/source/x/fcitx5-qt/fcitx5-qt.SlackBuild	2024-05-01 05:19:41.103516114 +0200
@@ -41,6 +41,11 @@
   esac
 fi
 
+# No more needed (successfully compiled qt6 without webengine), but leave it as option.
+if [ ! -f /usr/bin/qmake6 ]; then
+  QT6OPT="-DENABLE_QT6=Off"
+fi
+
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic"
   LIBDIRSUFFIX=""
@@ -91,6 +95,7 @@
     -DCMAKE_INSTALL_PREFIX="/usr" \
     -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
     -DENABLE_QT4="Off" \
+    $QT6OPT \
     ..
 
   make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/x/glew/glew.SlackBuild slackware64-current.3/source/x/glew/glew.SlackBuild
--- slackware64-current.2/source/x/glew/glew.SlackBuild	2021-02-13 06:32:07.791944753 +0100
+++ slackware64-current.3/source/x/glew/glew.SlackBuild	2021-09-18 13:42:56.207063200 +0200
@@ -89,8 +89,11 @@
 # Use lib${LIBDIRSUFFIX} (if needed) in Makefile:
 sed -i "s,/lib,/lib${LIBDIRSUFFIX},g" Makefile
 
-make $NUMJOBS OPT="$SLKCFLAGS" || make OPT="$SLKCFLAGS" || exit 1
-make install.all GLEW_DEST=$PKG/usr || exit 1
+# Add AArch64 architecture (and new architectures):
+\cp /usr/share/libtool/build-aux/config.* config/
+
+make $NUMJOBS OPT="$SLKCFLAGS" LIBDIR=/usr/lib$LIBDIRSUFFIX || make OPT="$SLKCFLAGS" LIBDIR=/usr/lib$LIBDIRSUFFIX || exit 1
+make install.all DESTDIR=$PKG LIBDIR=/usr/lib$LIBDIRSUFFIX || exit 1
 
 chmod 755 $PKG/usr/lib${LIBDIRSUFFIX}/libGLEW*.so.*
 rm -f $PKG/usr/lib${LIBDIRSUFFIX}/libGLEW*.a
diff -ur slackware64-current.2/source/x/ibus/ibus.SlackBuild slackware64-current.3/source/x/ibus/ibus.SlackBuild
--- slackware64-current.2/source/x/ibus/ibus.SlackBuild	2021-07-04 18:32:55.599325278 +0200
+++ slackware64-current.3/source/x/ibus/ibus.SlackBuild	2021-09-18 13:42:56.237064714 +0200
@@ -79,6 +79,10 @@
 tar xvf $CWD/ibus-$VERSION.tar.?z || exit 1
 cd ibus-$VERSION || exit 1
 
+# On platform that does not support unaligned 32bit load (mips, armv5), force
+# the start of 32bit array on 4 bytes boundary:
+zcat $CWD/align32bit_word.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/x/libdrm/libdrm.SlackBuild slackware64-current.3/source/x/libdrm/libdrm.SlackBuild
--- slackware64-current.2/source/x/libdrm/libdrm.SlackBuild	2024-08-27 19:14:03.356027232 +0200
+++ slackware64-current.3/source/x/libdrm/libdrm.SlackBuild	2025-01-07 13:31:35.423284225 +0100
@@ -74,6 +74,18 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+if [ "${ARCH::3}" = "arm" -o "$ARCH" = "aarch64" ]; then
+  EXTRABUILD="-Dintel=enabled
+              -Domap=enabled
+	      -Dexynos=enabled
+	      -Dtegra=enabled
+	     "
+elif [ "${ARCH::3}" = "ppc" -o "${ARCH::4}" = "mips" ]; then
+  EXTRABUILD="-Dintel=enabled"
+else
+  EXTRABUILD=${EXTRABUILD:-""}
+fi
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
@@ -90,6 +102,7 @@
   --mandir=/usr/man \
   --sysconfdir=/etc \
   --localstatedir=/var \
+  $EXTRABUILD \
   --buildtype=release \
   -Dudev=true \
   -Dintel=enabled \
diff -ur slackware64-current.2/source/x/libime/libime.SlackBuild slackware64-current.3/source/x/libime/libime.SlackBuild
--- slackware64-current.2/source/x/libime/libime.SlackBuild	2024-12-12 20:41:03.063680231 +0100
+++ slackware64-current.3/source/x/libime/libime.SlackBuild	2025-01-07 13:31:35.573292249 +0100
@@ -69,6 +69,9 @@
 tar xvf $CWD/libime-${VERSION}_dict.tar.zst || exit 1
 cd libime-$VERSION || exit 1
 
+# Fix unaligned copy for hppa, mips*, and sparc* (bus error), arm already present:
+zcat $CWD/unaligned_copy.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current/source/x/libpinyin/libpinyin.SlackBuild slackware64-current.2/source/x/libpinyin/libpinyin.SlackBuild
--- slackware64-current/source/x/libpinyin/libpinyin.SlackBuild	2022-12-13 12:34:45.189372723 +0100
+++ slackware64-current.2/source/x/libpinyin/libpinyin.SlackBuild	2023-02-28 12:34:08.211129371 +0100
@@ -79,6 +79,8 @@
 tar xvf $CWD/libpinyin-$VERSION.tar.?z || exit 1
 cd libpinyin-$VERSION || exit 1
 
+zcat $CWD/unaligned_access_traling_zeros.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/x/mesa/mesa.SlackBuild slackware64-current.3/source/x/mesa/mesa.SlackBuild
--- slackware64-current.2/source/x/mesa/mesa.SlackBuild	2024-10-16 20:45:39.777012298 +0200
+++ slackware64-current.3/source/x/mesa/mesa.SlackBuild	2025-07-01 16:16:00.000000000 +0100
@@ -33,9 +33,6 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
-# Be sure this list is up-to-date:
-GALLIUM_DRIVERS="nouveau,r300,r600,svga,radeonsi,softpipe,llvmpipe,virgl,i915,iris,crocus,zink,d3d12"
-
 if [ -z "$ARCH" ]; then
   case "$( uname -m )" in
     i?86) export ARCH=i686 ;;
@@ -44,6 +41,19 @@
   esac
 fi
 
+# Be sure this list is up-to-date:
+GALLIUM_DRIVERS="nouveau,r300,r600,radeonsi,softpipe,llvmpipe,virgl,zink,d3d12"
+VULKAN_DRIVERS="amd,swrast"
+VULKAN_LAYERS="device-select,overlay"
+
+case "$ARCH" in
+  i?86 | x86_64) 
+    GALLIUM_DRIVERS="svga,iris,i915,crocus,$GALLIUM_DRIVERS"
+    VULKAN_DRIVERS="intel,intel_hasvk,virtio,$VULKAN_DRIVERS"
+    VULKAN_LAYERS="intel-nullhw,$VULKAN_LAYERS"
+    ;;
+esac
+
 # If the variable PRINT_PACKAGE_NAME is set, then this script will report what
 # the name of the created package would be, and then exit. This information
 # could be useful to other scripts.
@@ -112,6 +122,21 @@
   tar xvf $CWD/mesa-subprojects.tar.lz || exit 1
 fi
 
+which bindgen >/dev/null
+if [ $? -eq 0 ]; then
+  RUSTICL="-Dgallium-rusticl=true -Drust_std=2021"
+  if [ `gcc -dM -E - < /dev/null | grep -cE '__BYTE_ORDER__.*__ORDER_BIG_ENDIAN__'` -eq 0 ]; then
+    VULKAN_DRIVERS="nouveau,$VULKAN_DRIVERS"
+  fi
+else
+  RUSTICL=""
+fi
+
+which valgrind >/dev/null 2>&1
+if [ $? -eq 0 ]; then
+  VALGRIND="-Dvalgrind=enabled"
+fi
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
@@ -132,12 +155,11 @@
   --localstatedir=/var \
   --buildtype=release \
   -Dplatforms=x11,wayland \
-  -Dgallium-rusticl=true \
   -Dgallium-extra-hud=true \
-  -Drust_std=2021 \
+  $RUSTICL \
   -Dgallium-drivers=$GALLIUM_DRIVERS \
-  -Dvulkan-drivers=amd,intel,intel_hasvk,swrast,virtio,nouveau \
-  -Dvulkan-layers=device-select,intel-nullhw,overlay \
+  -Dvulkan-drivers=$VULKAN_DRIVERS \
+  -Dvulkan-layers=$VULKAN_LAYERS \
   -Dvideo-codecs="$CODECS" \
   -Dglvnd=enabled \
   -Dllvm=enabled \
@@ -151,7 +174,7 @@
   -Dglx=dri \
   -Dlibunwind=disabled \
   -Dmicrosoft-clc=disabled \
-  -Dvalgrind=enabled \
+  $VALGRIND \
   $INTELRT \
   .. || exit 1
 
diff -ur slackware64-current.2/source/x/mesa/mesa-amber.build slackware64-current.3/source/x/mesa/mesa-amber.build
--- slackware64-current.2/source/x/mesa/mesa-amber.build	2022-08-08 23:46:48.013005690 +0200
+++ slackware64-current.3/source/x/mesa/mesa-amber.build	2022-08-13 08:10:13.569335845 +0200
@@ -6,7 +6,13 @@
 
 
 # Be sure this list is up-to-date:
-DRI_DRIVERS="i915,i965,r100,r200,nouveau"
+DRI_DRIVERS="r100,r200,nouveau"
+
+case "$ARCH" in
+  i?86 | x86_64) 
+    DRI_DRIVERS="i915,i965,$DRI_DRIVERS"
+    ;;
+esac
 
 cd $TMP
 rm -rf ${PKGNAM}-${AMBERVERS}
diff -ur slackware64-current.2/source/x/vulkan-sdk/vulkan-sdk.SlackBuild slackware64-current.3/source/x/vulkan-sdk/vulkan-sdk.SlackBuild
--- slackware64-current.2/source/x/vulkan-sdk/vulkan-sdk.SlackBuild	2023-11-24 06:23:56.876038563 +0100
+++ slackware64-current.3/source/x/vulkan-sdk/vulkan-sdk.SlackBuild	2024-02-07 18:04:36.206795221 +0100
@@ -580,6 +624,11 @@
 # Remove FindSDL3.cmake since we provided system one:
 \rm cmake/FindSDL3.cmake
 
+# Added OpenXR seems buggy on 64 bit:
+zcat $CWD/gfxreconstruct-openxr-64bit-fix.diff.gz | patch -p1 --verbose || exit 1
+
+zcat $CWD/platform_unknown.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -593,18 +634,19 @@
 
 mkdir -p build
 cd build
   cmake \
     -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS -Wno-error=stringop-overflow" \
     -DCMAKE_BUILD_TYPE=Release \
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DCMAKE_INSTALL_LIBDIR=lib$LIBDIRSUFFIX \
+    $CMAKE_EXTRA \
     ..
 
   make $NUMJOBS || make || exit 1
   make install DESTDIR=$PKG || exit 1
 
 cd $TMP
 tar xvf $CWD/DirectXShaderCompiler-$DXC_VERSION.tar.?z || exit 1
 cd $TMP/DirectXShaderCompiler-$DXC_VERSION
 
@@ -612,18 +654,27 @@
 cat $CWD/DirectXShaderCompiler.noverify.patch | patch -p1 --verbose || exit 1
 
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
   -exec chmod 755 {} \+ -o \
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Patching incorrect vector (instead of __vector) definition in Altivec code
+zcat $CWD/altivec_vector.diff.gz | patch -p1 --verbose || exit 1
+
+# Adding riscv support:
+zcat $CWD/riscv-support.diff.gz | patch -p1 --verbose || exit 1
+
+# Add AArch64 architecture (and new architectures):
+\cp /usr/share/libtool/build-aux/config.* autoconf/
+
 mkdir -p build/docs
 cd build
   cmake \
     -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS -Wno-error=stringop-truncation" \
     -DCMAKE_BUILD_TYPE=Release \
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DCMAKE_INSTALL_LIBDIR=lib$LIBDIRSUFFIX \
     -DCMAKE_INSTALL_INCLUDEDIR=include/dxc \
@@ -641,20 +651,23 @@
   cp -P lib$LIBDIRSUFFIX/libdxcompiler.so* $PKG/usr/lib$LIBDIRSUFFIX/
   cp -r ../include/dxc $PKG/usr/include/
 
   # Remove CMakeLists.txt files in /usr/include
   find $PKG/usr/include/dxc -name "CMakeLists.txt" | xargs rm -f
 
 cd $TMP
 tar xvf $CWD/SPIRV-Reflect-vulkan-sdk-$SPIRV_REFLECT_VERSION.tar.?z || exit 1
 cd $TMP/SPIRV-Reflect-vulkan-sdk-$SPIRV_REFLECT_VERSION
 
+# Add AArch64 architecture (and new architectures):
+\cp /usr/share/libtool/build-aux/config.* autoconf/
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
   -exec chmod 755 {} \+ -o \
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
 mkdir -p build
 cd build
   cmake \
diff -ur slackware64-current.2/source/x/x11/arch.use.flags slackware64-current.3/source/x/x11/arch.use.flags
--- slackware64-current.2/source/x/x11/arch.use.flags	2024-08-22 09:41:42.797592349 +0200
+++ slackware64-current.3/source/x/x11/arch.use.flags	2024-08-22 11:50:27.348448588 +0200
@@ -1,5 +1,7 @@
 if [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=pentium4 -mtune=generic -mstackrealign -fcommon -Wno-error=incompatible-pointer-types"
+elif [ "$ARCH" = "i586" ]; then
+  SLKCFLAGS="-O2 -march=i586 -mtune=i686 -mstackrealign -fcommon -Wno-error=incompatible-pointer-types"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -march=x86-64 -mtune=generic -fPIC -Wno-error=incompatible-pointer-types"
 else
diff -ur slackware64-15.0.orig/source/x/x11/configure/igt-gpu-tools slackware64-15.0.work/source/x/x11/configure/igt-gpu-tools
--- slackware64-15.0.orig/source/x/x11/configure/igt-gpu-tools	2021-04-23 19:48:51.690704921 +0200
+++ slackware64-15.0.work/source/x/x11/configure/igt-gpu-tools	2023-08-31 12:46:01.465385680 +0200
@@ -1,3 +1,6 @@
+if [[ "$ARCH" = "sparc" ]]; then
+  MESON_C_LINK_ARGS="-Dc_link_args=-latomic"
+fi
 CFLAGS="$SLKCFLAGS -Wno-error=array-bounds" \
 CXXFLAGS=$SLKCFLAGS \
 mkdir meson-build
@@ -12,4 +15,5 @@
   -Ddocs=disabled \
   -Dtests=disabled \
   -Drunner=disabled \
-  .. || exit 1
+  $MESON_C_LINK_ARGS \
+  ..
diff -ur slackware64-15.0.orig/source/x/x11/configure/libxcvt slackware64-15.0.work/source/x/x11/configure/libxcvt
--- slackware64-15.0.orig/source/x/x11/configure/libxcvt	2022-05-21 06:33:17.256400502 +0200
+++ slackware64-15.0.work/source/x/x11/configure/libxcvt	2023-08-31 14:54:43.321713262 +0200
@@ -14,4 +14,4 @@
   --sysconfdir /etc \
   --localstatedir /var \
   --buildtype=release \
-  .. || exit 1
+  ..
diff -ur slackware64-current.2/source/x/x11/configure/pixman slackware64-current.3/source/x/x11/configure/pixman
--- slackware64-current.2/source/x/x11/configure/pixman	2024-01-05 12:15:58.676832328 +0100
+++ slackware64-current.3/source/x/x11/configure/pixman	2024-01-05 15:33:12.413893301 +0100
@@ -5,6 +5,9 @@
   do_sse2=enabled
 else
   do_sse2=disabled
+  if [ "$ARCH" = "arm" ]; then
+    do_sse2="$do_sse2 -Darm-simd=disabled -Dneon=disabled"
+  fi
 fi
 
 export CFLAGS="$SLKCFLAGS"
diff -ur slackware64-15.0.orig/source/x/x11/configure/xisxwayland slackware64-15.0.work/source/x/x11/configure/xisxwayland
--- slackware64-15.0.orig/source/x/x11/configure/xisxwayland	2020-05-18 19:50:24.669979606 +0200
+++ slackware64-15.0.work/source/x/x11/configure/xisxwayland	2023-08-31 12:05:23.263687546 +0200
@@ -14,4 +14,4 @@
   --sysconfdir /etc \
   --localstatedir /var \
   --buildtype=release \
-  .. || exit 1
+  .. 
diff -ur slackware64-15.0.orig/source/x/x11/configure/xkeyboard-config slackware64-15.0.work/source/x/x11/configure/xkeyboard-config
--- slackware64-15.0.orig/source/x/x11/configure/xkeyboard-config	2022-02-10 19:52:47.145013268 +0100
+++ slackware64-15.0.work/source/x/x11/configure/xkeyboard-config	2023-08-31 14:54:34.881286463 +0200
@@ -16,4 +16,4 @@
   --buildtype=release \
   -Dcompat-rules=true \
   -Dxorg-rules-symlinks=true \
-  .. || exit 1
+  ..
diff -ur slackware64-15.0.orig/source/x/x11/configure/xorgproto slackware64-15.0.work/source/x/x11/configure/xorgproto
--- slackware64-15.0.orig/source/x/x11/configure/xorgproto	2018-03-17 18:33:59.047545400 +0100
+++ slackware64-15.0.work/source/x/x11/configure/xorgproto	2023-08-31 12:05:49.051650835 +0200
@@ -15,4 +15,4 @@
   --localstatedir /var \
   --buildtype=release \
   -Dlegacy=true \
-  .. || exit 1
+  .. 
diff -ur slackware64-current.2/source/x/x11/configure/xorg-server slackware64-current.3/source/x/x11/configure/xorg-server
--- slackware64-current.2/source/x/x11/configure/xorg-server	2024-03-25 20:08:21.557014687 +0100
+++ slackware64-current.3/source/x/x11/configure/xorg-server	2025-01-07 13:31:36.373335040 +0100
@@ -47,6 +47,14 @@
 # Default font paths to be used by the X server:
 DEF_FONTPATH="/usr/share/fonts/misc,/usr/share/fonts/local,/usr/share/fonts/TTF,/usr/share/fonts/OTF,/usr/share/fonts/Type1,/usr/share/fonts/CID,/usr/share/fonts/75dpi/:unscaled,/usr/share/fonts/100dpi/:unscaled,/usr/share/fonts/75dpi,/usr/share/fonts/100dpi,/usr/share/fonts/cyrillic"
 
+INT10=x86emu
+case "$ARCH" in
+  mips*) 
+    INT10=stub
+    SLKCFLAGS="$SLKCFLAGS -fcommon"
+    ;;
+esac
+
 # Reconf (don't remove this plz):
 autoreconf -vif
 
@@ -60,7 +68,7 @@
   --mandir=/usr/man \
   --disable-static \
   --with-pic \
-  --with-int10=x86emu \
+  --with-int10=$INT10 \
   --with-default-font-path="${DEF_FONTPATH}" \
   --with-module-dir=/usr/lib${LIBDIRSUFFIX}/xorg/modules \
   --with-os-name="Slackware 15.1" \
diff -ur slackware64-current.2/source/x/x11/modularize slackware64-current.3/source/x/x11/modularize
--- slackware64-current.2/source/x/x11/modularize	2021-02-13 22:06:16.101014833 +0100
+++ slackware64-current.3/source/x/x11/modularize	2021-09-18 13:43:06.117563421 +0200
@@ -180,12 +181,15 @@
 xf86-input-wacom
 xf86-video-amdgpu
 xf86-video-apm
+xf86-video-armsoc
 xf86-video-ark
 xf86-video-ast
 xf86-video-ati
 xf86-video-chips
 xf86-video-cirrus
 xf86-video-dummy
+xf86-video-fbdev
+xf86-video-fbturbo
 xf86-video-geode
 xf86-video-glint
 xf86-video-i128
@@ -198,6 +202,7 @@
 xf86-video-nv
 xf86-video-omap
 xf86-video-openchrome
+xf86-video-opentegra
 xf86-video-qxl
 xf86-video-r128
 xf86-video-rendition
diff -ur slackware64-current.2/source/x/x11/post-install/xorg-cf-files.post-install slackware64-current.3/source/x/x11/post-install/xorg-cf-files.post-install
--- slackware64-current.2/source/x/x11/post-install/xorg-cf-files.post-install	2023-06-06 09:38:48.000000000 +0200
+++ slackware64-current.3/source/x/x11/post-install/xorg-cf-files.post-install	2023-06-13 13:58:13.195424432 +0200
@@ -1,4 +1,4 @@
-if [[ "$(uname -m)" =~ (x86_64|aarch64|riscv64) ]]; then
+if [[ "$(uname -m)" =~ (x86_64|aarch64|riscv64) || "$LIBDIRSUFFIX" = "64" ]]; then
   ( cd $PKG/usr/lib/X11/config
     zcat $CWD/post-install/xorg-cf-files/x11.tmpl.lib64.kludge.diff.gz | patch -p1 || exit 1
   )
diff -ur slackware64-current.2/source/x/x11/x11.SlackBuild slackware64-current.3/source/x/x11/x11.SlackBuild
--- slackware64-current.2/source/x/x11/x11.SlackBuild	2020-02-19 21:37:54.752789884 +0100
+++ slackware64-current.3/source/x/x11/x11.SlackBuild	2021-09-18 13:43:06.187566954 +0200
@@ -163,7 +163,12 @@
         if grep -wq "^$PKGNAME" ${CWD}/noarch ; then
           PKGARCH=noarch
         fi 
-        if grep -wq "^$PKGNAME" ${CWD}/package-blacklist ; then
+	blacklist=package-blacklist
+	if [ -r ${CWD}/$blacklist.$ARCH ]
+	then
+	  blacklist=$blacklist.$ARCH
+	fi
+        if grep -wq "^$PKGNAME" ${CWD}/$blacklist ; then
           continue
         fi
         cd $SLACK_X_BUILD_DIR
@@ -225,6 +230,19 @@
           . $CWD/patch/${PKGNAME}.patch
         fi
 
+	# Fix architecture guess for AArch64 and new architectures
+	auxdir="."
+	if [ -d "build-aux" ]
+	then
+	  auxdir="build-aux/"
+	fi
+	\cp /usr/share/libtool/build-aux/config.* $auxdir
+
+	# Fix configure to support shared libraries for PPC64LE and new architectures
+	if [ -x /usr/share/libtool/build-aux/fix_configure ]; then
+	  /usr/share/libtool/build-aux/fix_configure
+	fi
+
         # I heard somewhere that -O2 breaks some chipset or another.  If you encounter
         # problems, please contact volkerdi@slackware.com.  Thanks! :-)
 
